---
title: 'Square tilemaps implementation: Scrolling maps'
slug: 'Games/Techniques/Tilemaps/Square_tilemaps_implementation:_Scrolling_maps'
tags:
  - Canvas
  - Games
  - JavaScript
  - atlas
  - scrolling
  - spritesheet
  - tilemap
  - tiles
---
<div>{{GamesSidebar}}</div>

<p class="summary">This article covers how to implement scrolling square tilemaps using the <a href="/en-US/docs/Web/API/Canvas_API">Canvas API</a>.</p>

<div class="note">
<p><strong>Note</strong>: When writing this article, we assumed previous reader knowledge of canvas basics such as how get a 2D canvas context, load images, etc., which is all explained in the <a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas API tutorial</a>, as well as the basic information included in our <a href="/en-US/docs/Games/Techniques/Tilemaps">Tilemaps</a> introduction article. This article also builds upon <a href="/en-US/docs/Games/Techniques/Tilemaps/SquareTiles/Square_tilemaps_implementation:_Static_maps">implementing static square tilemaps</a> — you should read that too if you've not done so already.</p>
</div>

<h2 id="The_camera">The camera</h2>

<p>The camera is an object that holds information about which section of the game world or level is currently being shown. Cameras can either be free-form, controlled by the player (such as in strategy games) or follow an object (such as the main character in platform games.)</p>

<p>Regardless of the type of camera, we would always need information regarding its current position, viewport size, etc. In the <a href="https://mozdevs.github.io/gamedev-js-tiles/square/scroll.html">demo provided</a> along with this article, these are the parameters the camera has:</p>

<ul>
 <li><code>x</code> and <code>y</code>: The current position of the camera. In this implementation, we are assuming that <code>(x,y)</code> points to the top left corner of visible portion of the map.</li>
 <li><code>width</code> and <code>height</code>: The size of the camera's viewport.</li>
 <li><code>maxX</code> and <code>maxY</code>: The limit for the camera's position — The lower limit will nearly always be (0,0), and in this case the upper limit is equal to the size of the world minus the size of the camera's viewport.</li>
</ul>

<h2 id="Rendering_the_map">Rendering the map</h2>

<p>There are two main differences between rendering scrolling maps vs. static maps:</p>

<ul>
 <li><strong>Partial tiles might be shown</strong>. In static maps, usually the rendering starts at the top left corner of a tile situated at the top left corner of a viewport. While rendering scrolling tilemaps, the first tile will often be clipped.</li>
</ul>

<p>TODO: show a diagram here explaining this.</p>

<ul>
 <li><strong>Only a section of the map will be rendered</strong>. If the map is bigger than the viewport, we can obviously only display a part of it at a time, whereas non-scrolling maps are usually rendered wholly.</li>
</ul>

<p>To handle these issues, we need to slightly modify the rendering algorithm. Let's imagine that we have the camera pointing at <code>(5,10)</code>. That means that the first tile would be <code>0x0</code>. In the demo code, the starting point is stored at <code>startCol</code> and <code>startRow</code>. It's convenient to also pre-calculate the last tile to be rendered.</p>

<pre class="brush: js">    var startCol = Math.floor(this.camera.x / map.tsize);
    var endCol = startCol + (this.camera.width / map.tsize);
    var startRow = Math.floor(this.camera.y / map.tsize);
    var endRow = startRow + (this.camera.height / map.tsize);</pre>

<p>Once we have the first tile, we need to calculate how much its rendering (and therefore the rendering of the other tiles) is offset by. Since the camera  is pointing at <code>(5, 10)</code>, we know that the first tile should be shifted by <code>(-5,-10)</code> pixels. In our demo the shifting amount is stored in the <code>offsetX</code> and <code>offsetY</code> variables.</p>

<pre class="brush: js">    var offsetX = -this.camera.x + startCol * map.tsize;
    var offsetY = -this.camera.y + startRow * map.tsize;
</pre>

<p>With these values in place, the loop that renders the map is quite similar to the one used for rendering static tilemaps. The main difference is that we are adding the <code>offsetX</code> and <code>offsetY</code> values to the target <code>x</code> and <code>y</code> coordinates, and these values are rounded, to avoid artifacts that would result from the camera pointing at positions with floating point numbers.</p>

<pre class="brush: js">for (var c = startCol; c &lt;= endCol; c++) {
        for (var r = startRow; r &lt;= endRow; r++) {
            var tile = map.getTile(c, r);
            var x = (c - startCol) * map.tsize + offsetX;
            var y = (r - startRow) * map.tsize + offsetY;
            if (tile !== 0) { // 0 =&gt; empty tile
                this.ctx.drawImage(
                    this.tileAtlas, // image
                    (tile - 1) * map.tsize, // source x
                    0, // source y
                    map.tsize, // source width
                    map.tsize, // source height
                    Math.round(x),  // target x
                    Math.round(y), // target y
                    map.tsize, // target width
                    map.tsize // target height
                );
            }
        }
    }</pre>

<h2 id="Demo">Demo</h2>

<p>Our scrolling tilemap implementation demo pulls the above code together to show what an implementation of this map looks like. You can take a look at a <a href="https://mozdevs.github.io/gamedev-js-tiles/square/scroll.html">live demo</a>, and see <a href="https://github.com/mozdevs/gamedev-js-tiles">its source code</a>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11713/Untitled.gif" style="display: block; margin: 0px auto;"></p>

<p>There's <a href="https://mozdevs.github.io/gamedev-js-tiles/square/logic-grid.html">another demo available</a>, that shows how to make the camera follow a character.</p>
